
#include "smfs/smf_fat.h"

#define _ISR_STARTADDRESS 0xcffff00

#include "GP32.h"

#include "core.h"
#include "device.h"
//#include "io.h"
#include "screen.h"
//#include "font.h"
//#include "console.h"

volatile int frame_counter = 0;
void device_doirq(void);

extern void device_init(void);

volatile void irq_func(void) __attribute__((naked));
volatile void irq_func(void)
{
	asm volatile ("stmdb    sp!,{r0-r12,lr}\n");

	//device_doirq();

	frame_counter++;

	asm volatile (
		"ldmia    sp!,{r0-r12,lr}\n"
		"subs     pc,lr,#4\n"
		);
}

extern set_irq(int num, void *func);

void enable_irq(void);
void disable_irq(void);

void pogo_init(void)
{
	device_init();
	screen_init();
}

void timer_init() {
	disable_irq();

	rINTMOD = 0;						// No FIQ interrupts
	rINTMSK = 0xFFFFFFFF;				// Mask all interrupts

	set_irq(11, irq_func);

	rTCFG0 = 0xc0;	// Timer0&1 prescaler
	rTCFG1 = 0x33;	// Divider 1/16

	//rTCNTB1 = 300;	// Interval
	rTCNTB1 = 30;	// Interval
	rTCON  = 0x0E00;	// Load buffer value into timer

	rTCON  = 0x0900;	// Set Timer0 interval and start

	rSRCPND = BIT_TIMER1; //m clear timer1 interrupt request
	rINTPND = BIT_TIMER1; //m clear timer1 int pending

	////rINTMOD=~(BIT_TIMER1);
	rINTMSK = ~(BIT_TIMER1); // Enable timer1 interrupts

	enable_irq();

}
