/*
 * Misc. functions (misc.c)
 * Part of libpogo, a c-library replacent for GBA
 * Programmed by Jonas Minnberg (Sasq)
 *
 * DESCRIPTION
 * Some general c-library functions
 *
 **/

#include "core.h"
#include "device.h"
#include "io.h"

time_t time(time_t *t)
{
	int l = clock()/CLOCKS_PER_SEC;
	if(t)
		*t = l;

	return l;
}

void exit(int rc)
{
	while(1);
}

int atexit(void *func)
{
	return 0;
}

void abort(void)
{
	while(1);
}

static int seed = 11177;

int rand(void)
{
	/* Completely bogus random numbers, to be fixed */
	seed = (seed * 119) ^ 19117;
	return (seed * 19517) + 1767;

}

void srand(unsigned int s)
{
	seed = s;
}

int __errno;

int errno;

void *calloc(int x, int y)
{
	void *p = malloc(x*y);
	memset(p, 0, x*y);
	return p;
}

void assert(int expr)
{
	if(!expr)
	{
		printf("Assertion failed\n");
		while(1);
	}
}

int fstat(int fd, struct stat *buf)
{
	return 0;
}

FILE *fdopen(int fd, char *mode)
{
	return (FILE *)fd;
}

int ferror(FILE *fp)
{
	return 0;
}
