#ifndef SCREEN_H
#define SCREEN_H

#include "core.h"

#define XY(x,y) ((x)*240-(y))
#define SCR_BASE 239

#define SCR_WIDTH 320
#define SCR_HEIGHT 240

#define DONT_DRAW 0x10000000

#define BPP_16 0x18
#define BPP_8  0x16
#define BPP_4  0x14
#define BPP_2  0x12
#define BPP_1  0x10

void screen_set(int bpp, int width, int height);
void screen_palette(uint16 *colors);
uint16 *screen_offset(int x, int y);
uint16 *screen_ptr(int pos);
void screen_copy_fg(uint16 *dest, uchar *src, int width, int height, int swidth);
void screen_copy(uint16 *dest, uchar *src, int width, int height, int swidth);
void screen_clear_bg(uint16 *dest, int width, int height);
void screen_set_fgbg(uint16 fgc, uint16 bgc);
void screen_scroll(int x, int y);
void screen_init(void);

#endif
