
	.ALIGN
	.ARM

	.GLOBAL		set_irq
	.GLOBAL		enable_irq
	.GLOBAL		disable_irq
	.GLOBAL		mmu_change
	.GLOBAL		wait_change
	.GLOBAL		cpu_speed

set_irq:

	stmdb	r13!, {r0-r12,lr}
	swi		#0x09
	ldmia	r13!, {r0-r12,lr}
	bx		lr
	nop

cpu_speed:

	stmdb	r13!, {r0-r12,lr}
	stmdb	sp!, {r0, r1, r2}
	mov		r0, sp
	swi		#0x0d
	add		sp, sp, #12
	ldmia	r13!, {r0-r12,lr}
	bx		lr
	nop

mmu_change:
	stmdb	r13!, {r0-r12,lr}
	swi		#0x02
	ldmia	r13!, {r0-r12,lr}
	bx		lr
	nop


enable_irq:
	mrs		r0,CPSR
	bic		r0,r0,#0x80
	msr		CPSR, r0
	bx		lr
	nop

disable_irq:
	mrs		r0,CPSR
	orr		r0,r0,#0xC0
	msr		CPSR, r0
	bx		lr
	nop

wait_change:
	ldr		r1,[r0]
0:
	ldr		r2,[r0]
	cmp		r1,r2
	beq		0b
	bx		lr
	nop
