
#include <gp32.h>

/*
        This routine initializes the i/o port used for L3-bus and
        then configures the UDA1330
*/

void Init1330(int fsflag,int type) {
        /****** I/O Port D Initialize ******/

        /* data */

        rPGCON |= 0xa0;

        /*port reconfiguration :
                PORTE 9,10,11 --> output
                pull-up disable
                L3_MODE, L3_CLK High
        */
        rPEDAT = (rPEDAT & ~0xe00) | (L3M|L3C);
        rPEUP |= 0xe00;
        rPECON = (rPECON & (~(0x3f << 18))) | (0x15<<18);

    /****** send commands via L3 Interface
     Data bits 7 to 2 represent a 6-bit device address where bit 7 is the MSB.
     The address of the UDA1330ATS is 000101 (bit 7 to bit 2).
    ******/

    /* status type transfer , data value - clock=384fs, MSB format */
    _WrL3Addr(0x14+2); //STATUS (0) (000101xx+10)
    _WrL3Data(
              (fsflag<<4)+  //  00,  : 512,384,256fs         (SC : System Clock Freq)
              (type<<1)   // 000,  : iis,lsb16,lsb18,lsb20,msb
              ,1);
//    _WrL3Addr(0x14+2); //STATUS (0) (000101xx+10)
//    _WrL3Data(
////              (2<<4)+  //   0,  :               ( = 0 )
////              (1<<4)+  //   0,  :               ( = 0 )
//              (0<<4)+  //   0,  :               ( = 0 )
//              (4<<1)   // 000,  : iis,lsb16,lsb18,lsb20,msb
////              (1<<1)   // 000,  : iis,lsb16,lsb18,lsb20,msb
////              (0<<1)   // 000,  : iis,lsb16,lsb18,lsb20,msb
//              ,1);
                       //   1,  : reset         /* not 1330A ?! */
                       //  10,  : 256fs         (SC : System Clock Freq)
                       //   0   : no DCfilter   (DC : DC Filter) /* not 1330A */

//        //data type transfer // data value - full volume
//        _WrL3Addr(0x14 + 0);                    //DATA0 (000101xx+00)
//        _WrL3Data(0x3f, 1);

//        //data type transfer // data value - no de emphasis, no muting
//        _WrL3Addr(0x14 + 0);
//        _WrL3Data(0x80+
//                (2<<3) // de-emp 44khz
//                ,1);
          GpControlVolume(0x3f);

}














