#include <gp32.h>

void InitIIS(int bits,int type,int mclk,int bclk,int prea,int preb) {

    /****** IIS Initialize ******/

    rIISCON=/* 8,7,6 readonly */
            (0<<5)+  /* dma transmit request enable */
            (0<<4)+  /* dma recieve request disable */
            (1<<3)+  /* Transmit LR-Clock idle state */
            (1<<2)+  /* Recieve LR-Clock idle state */
            (1<<1)+  /* prescaler enabled */
            (0<<0);  /* iis disabled */
    rIISFIFCON=0;

    rIISMOD=
            (0<<8)+             /* master mode,slave mode */
            (2<<6)+             /* transmit mode */
            (0<<5)+             /* lowbyte=left channel */
            (type<<4)+             /* iis compatible samples / MSB samples */
            (bits<<3)+             /* 16 bit per channel */
            (mclk<<2)+             /* master clock    256,384fs */
            (bclk<<0);             /* serial bitclock 16,32,48fs */

    rIISFIFCON=
               (1<<11)+   /* transmit fifo mode = dma */
               (0<<10)+   /* recieve fifo mode = normal */
               (1<<9)+    /* transmit fifo enable */
               (0<<8);    /* recieve fifo disable */
                /* 7-4 Transmit Fifo Data Count (readonly) */
                /* 3-0 Recieve Fifo Data Count (readonly) */

    /* prescaler (<<5 is correct, NOT <<4 !) */
    rIISPSR=(prea<<5)+preb;

    /****** IIS Tx Start ******/
    rIISCON=/* 8,7,6 readonly */
            (1<<5)+  /* dma transmit request enable */
            (0<<4)+  /* dma recieve request disable */
            (0<<3)+  /* Transmit LR-Clock idle state */
            (1<<2)+  /* Recieve LR-Clock idle state */
            (1<<1)+  /* prescaler enabled */
            (1<<0);  /* iis enabled */
}
