
// #define USEREALRTC

#include <gp32.h>

unsigned long bcd2int(unsigned long bcd){
unsigned long  val;
 	val=(bcd&0xf);bcd>>=4;
	val=(bcd&0xf)*10;bcd>>=4;
	val=(bcd&0xf)*100;bcd>>=4;
	val=(bcd&0xf)*1000;bcd>>=4;
	val=(bcd&0xf)*10000;bcd>>=4;
	val=(bcd&0xf)*100000;bcd>>=4;
	val=(bcd&0xf)*1000000;bcd>>=4;
	val=(bcd&0xf)*10000000;
}
#define bcd2int2(_bcd) (((_bcd)&0xf)+((((_bcd)>>4)&0xf)*10))

static unsigned long rtcstart_sec;

// RTC "Heartbeat"
volatile unsigned long _ticks=0;

static void RTC_Tick(void) __attribute__ ((naked));

static void RTC_Tick(void) {

        asm volatile ("
                STMDB    r13!,{r0-r12,lr}
                ");

		_ticks++;

    	rSRCPND=BIT_TIMER4;
    	rINTPND=BIT_TIMER4;
    	rINTPND;

        asm volatile ("
                LDMIA    r13!,{r0-r12,lr}
                SUBS PC,lr,#4
                ");

}

unsigned long gettickspermsec(void){
unsigned long PCLK,PRESC,DIVN;
unsigned long divn[4]={2,4,8,16};
	PCLK=GpPClkGet();
	PRESC=(rTCFG0>>8)&0xff;
	DIVN=divn[(rTCFG1>>16)&0x3];
//	return( ((PCLK/(PRESC+1))/DIVN)*0.0001  );
	return( ((PCLK/(PRESC+1))/DIVN)/1000 );
}


static unsigned long getrelsecs(void){
unsigned long sec,min,hr,day,mon,yr;

#ifdef USEREALRTC

//    rRTCCON = 0x01;
	yr=rBCDYEAR;
	mon=rBCDMON;
	day=rBCDDATE;
	hr=rBCDHOUR;
	min=rBCDMIN;
	sec=rBCDSEC;

	// 70,3e,3f,1b,ff

	if(sec>0x59){
	   sec=(0x50|(sec&0xf));
	}
	// 70..79 0..
	if(min>0x59){
	   min=(0x50|(min&0xf));
	}
	// 3e,3f 0..
	if(hr>0x23){
	   hr=(0x20|(hr&0xf));
	}
	// 3f 0..
	if(day>0x31){
	   day=(0x20|(day&0xf));
	}
	// 1b,1f 0..
	if(mon>0x12){
	   mon=(0x10|(mon&0xf));
	}
	// 3e,3f 0..
	if(yr>0x99){
	   yr=(0x90|(yr&0xf));
	}
	yr=bcd2int2(yr);
	mon=bcd2int2(mon);
   day=bcd2int2(day);
   hr=bcd2int2(hr);
   min=bcd2int2(min);
   sec=bcd2int2(sec);
//    rRTCCON = 0x00;

	if(yr==99)yr=1999;
	else yr+=2000;

	// thats not quite right
	yr*=12;
	yr+=mon;
	yr*=30;
	yr+=day;
	yr*=24;
	yr+=hr;
	yr*=60;
	yr+=min;
	yr*=60;
	yr+=sec;

#endif

	return(yr);
}


int gettimeofday(struct timeval *__p, struct timezone *__z){
unsigned long sec;
//unsigned long _mticks;

#ifdef USEREALRTC
	sec=getrelsecs();
#else
	sec=(_ticks/1000);
#endif
//	_mticks=gettickspermsec();

	__p->tv_sec=sec;
//  	__p->tv_usec=((_ticks%1000)*1000)+((rTCNTO4*1000)/_mticks);
  	__p->tv_usec=((_ticks%1000)*1000);

	return(__p->tv_sec);

}

int InitRTC(void){
unsigned char bcdstart_sec;

#ifdef USEREALRTC

	rRTCCON=((1<<3)|(0<<2)|(0<<1)|(0<<0));
	rBCDYEAR=1;
	rBCDMON=1;
	rBCDDAY=1;
	rBCDDATE=1;
	rBCDHOUR=1;
	rBCDMIN=1;
	rBCDSEC=1;
	rRTCCON=((0<<3)|(0<<2)|(0<<1)|(1<<0));
	rBCDYEAR=1;
	rBCDMON=1;
	rBCDDAY=1;
	rBCDDATE=1;
	rBCDHOUR=1;
	rBCDMIN=1;
	rBCDSEC=1;
	rRTCCON=((1<<3)|(0<<2)|(0<<1)|(1<<0));
	rBCDYEAR=1;
	rBCDMON=1;
	rBCDDAY=1;
	rBCDDATE=1;
	rBCDHOUR=1;
	rBCDMIN=1;
	rBCDSEC=1;
	rRTCCON=0;
	rBCDYEAR=1;
	rBCDMON=1;
	rBCDDAY=1;
	rBCDDATE=1;
	rBCDHOUR=1;
	rBCDMIN=1;
	rBCDSEC=1;
//	rRTCCON&=~1;
//	rRTCCON=(0<<3)|(0<<2)|(0<<1)|(1<<0);
#endif

    ARMDisableInterrupt();

        rINTMSK=0xffffffff;     // all irqs masked
//        swi_install_irq(nISR_TICK,(void*)&RTC_Tick);
        swi_install_irq(nISR_TIMER4,(void*)&RTC_Tick);

        /* irq regs */
//        rSRCPND     =BIT_TICK;
//        rINTPND     =BIT_TICK;
//        rINTMOD    &=~(BIT_TICK);
//        rINTMSK    &=~(BIT_TICK);

//        rSRCPND     =BIT_TIMER4;
//        rINTPND     =BIT_TIMER4;
	    rINTMOD	   &=~(BIT_TIMER4);
	    rINTMSK	   &=~(BIT_TIMER4);
//  	rINTMSK |= (BIT_TIMER0|BIT_TIMER1|BIT_TIMER2|BIT_TIMER3|BIT_TIMER4);

//    rINTMSK = ~(BIT_TICK);
//    rRTCCON = 0x0;		//RTC  Control disable(for power consumption), 1/32768, Normal(merge), No reset
//    rTICINT = 127+(1<<7);	//START

    ARMEnableInterrupt();

#ifdef USEREALRTC
    rRTCCON = 0x1;		//RTC  Control disable(for power consumption), 1/32768, Normal(merge), No reset
    rTICINT = (0x40+(1<<7));	//START
//    rRTCCON = 0x0;		//RTC  Control disable(for power consumption), 1/32768, Normal(merge), No reset

	rBCDYEAR=1;
	rBCDMON=1;
	rBCDDAY=1;
	rBCDDATE=1;
	rBCDHOUR=1;
	rBCDMIN=1;
	rBCDSEC=1;
#endif

	rtcstart_sec=getrelsecs();

//    rTCFG0=0x10000;	    //Prescaler0/1=0, Deadzone=1
//	rTCFG1=0x04444; 	//all int, MUX

//    rTCFG0=0x10000;	    //Prescaler0/1=0, Deadzone=1
//	rTCON=(1<<22)|(1<<21)|(1<<20)|(1<<4);


//    rTCNTB0=2000;	//Total cont=2000
//    rTCNTB1=2000;
//    rTCNTB2=2000;
//    rTCNTB3=2000;
//	rTCNTB4=0xffff;

//    rTCMPB0=2000-1000;	//(H/L)duty 50%
//    rTCMPB1=2000-1000;
//    rTCMPB2=2000-1000;
//    rTCMPB3=2000-1000;

//	rTCON=(1<<22)|(0<<21)|(1<<20)|(1<<4);

//    rTCON=0x6aaa0a;	//auto reload, inverter off, manual update, dead zone off
//    //rTCON=0x6aaa1a;	//auto reload, inverter off, manual update, dead zone on
//    //Uart_Printf("rTCON=0x%x\n",rTCON);
//    //rTCON=0x6eee0e;	//auto reload, inverter on, manual update, dead zone off
//    //Uart_Getch();
//    rTCON=0x599909;	//start PWM operation

	// calibrate usec timer
	{
		int tv;

//		rTCNTB4=0xffff;

//		{
//			int t=rBCDSEC;
//			while(t==rBCDSEC){};
//		}
//		// start timer
//		rTCON=(0<<22)|(0<<21)|(1<<20)|(1<<4);

//		{
//			int t=rBCDSEC;
//			while(t==rBCDSEC){};
//		}

//		rTCON=(0<<22)|(1<<21)|(0<<20)|(1<<4);
//		tv=0xffff-rTCNTO4;

    	rTCFG0=0x1f00;			//dead zone=0,pre1=0xf,pre0=0xf
    	rTCFG1=0x033333;	    //all int, 1/2MUX

		tv=gettickspermsec();

		rTCON=(0<<22)|(1<<21)|(0<<20)|(0<<4);
		rTCNTB4=tv;

#ifdef USEREALRTC
		// sync to RTC
		{
			int t=rBCDSEC;
			while(t==rBCDSEC){};
		}
#endif

		// start timer
		rTCON=(1<<22)|(0<<21)|(1<<20)|(0<<4);

		return(1000);
	}

}

