/*
 *  main.cpp - Main program
 *
 *  Frodo (C) 1994-1997,2002 Christian Bauer
 */

#include "sysdeps.h"

#include "main.h"
#include "C64.h"
#include "Display.h"
#include "Prefs.h"
#include "SAM.h"

#include "basicrom.h"
#include "kernalrom.h"
#include "charrom.h"
#include "1541rom.h"

// Global variables
char AppDirPath[1024];	// Path of application directory


// ROM file names
#ifdef __riscos__
#define BASIC_ROM_FILE	"FrodoRsrc:Basic_ROM"
#define KERNAL_ROM_FILE	"FrodoRsrc:Kernal_ROM"
#define CHAR_ROM_FILE	"FrodoRsrc:Char_ROM"
#define FLOPPY_ROM_FILE	"FrodoRsrc:1541_ROM"
#else
#define BASIC_ROM_FILE	"Basic ROM"
#define KERNAL_ROM_FILE	"Kernal ROM"
#define CHAR_ROM_FILE	"Char ROM"
#define FLOPPY_ROM_FILE	"1541 ROM"
#endif


/*
 *  Load C64 ROM files
 */

#ifndef __PSXOS__
bool Frodo::load_rom_files(void)
{
	FILE *file;
	int i;

	// Load Basic ROM
	for(i=0; i<0x2000; i++) *(TheC64->Basic+i)=*(basicrom+i);

	// Load Kernal ROM
	for(i=0; i<0x2000; i++) *(TheC64->Kernal+i)=*(kernalrom+i);

	// Load Char ROM
	for(i=0; i<0x1000; i++) *(TheC64->Char+i)=*(charrom+i);

	// Load 1541 ROM
	for(i=0; i<0x4000; i++) *(TheC64->ROM1541+i)=*(rom1541+i);

	return true;
}
#endif


#ifdef __BEOS__
#include "main_Be.i"
#endif

#ifdef AMIGA
#include "main_Amiga.i"
#endif

#ifdef __unix
#include "main_x.i"
#endif

#ifdef __mac__
#include "main_mac.i"
#endif

#ifdef WIN32
#include "main_WIN32.i"
#endif

#ifdef __riscos__
#include "main_Acorn.i"
#endif

#ifdef __PSXOS__
#include "main_PSX.i"
#endif

#ifdef GP32
#include "main_GP32.i"
#endif
